//+---------------------------------------------------------------------+ 
//|                                           Cronex Super Position.mq5 | 
//|                                           Copyright  2007, Cronex. |
//|                                          http://www.metaquotes.net/ |
//+---------------------------------------------------------------------+
//|          SmoothAlgorithms.mqh |
//|   (): MetaTrader\\MQL5\Include                      |
//+---------------------------------------------------------------------+
#property  copyright "Copyright  2007, Cronex"
#property  link      "http://www.metaquotes.net/"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----    7
#property indicator_buffers 7 
//----  6  
#property indicator_plots   6
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1 DRAW_LINE
//----       Silver
#property indicator_color1 Silver
//----   -  
#property indicator_style1 STYLE_SOLID
//----     1
#property indicator_width1 1
//----   
#property indicator_label1  "RSI Super Position"

//----     
#property indicator_type2 DRAW_LINE
//----       DarkOrange
#property indicator_color2 DarkOrange
//----   -  
#property indicator_style2 STYLE_SOLID
//----     1
#property indicator_width2 1
//----   
#property indicator_label2  "DeMarker Super Position"

//----     
#property indicator_type3 DRAW_LINE
//----       Black
#property indicator_color3 Black
//----   -  
#property indicator_style3 STYLE_SOLID
//----     1
#property indicator_width3 1
//----   
#property indicator_label3  "Cronex Super Position"

//----     
#property indicator_type4 DRAW_LINE
//----       Red
#property indicator_color4 Red
//----   -  
#property indicator_style4 STYLE_SOLID
//----     1
#property indicator_width4 1
//----    
#property indicator_label4  "Fast Signal Line"

//----     
#property indicator_type5 DRAW_LINE
//----       Blue
#property indicator_color5 Blue
//----   -  
#property indicator_style5 STYLE_SOLID
//----     1
#property indicator_width5 1
//----    
#property indicator_label5  "Slow Signal Line"

//----      
#property indicator_type6 DRAW_COLOR_HISTOGRAM
//----       Gray,Teal,BlueViolet,IndianRed,Magenta 
#property indicator_color6 Gray,Teal,BlueViolet,IndianRed,Magenta
//----   - 
#property indicator_style6 STYLE_SOLID
//----     3
#property indicator_width6 3
//----   
#property indicator_label6 "Super Position Divergence"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 -0.20
#property indicator_level2  0.20
#property indicator_level3  0.50
#property indicator_level4  0.80
#property indicator_levelcolor Gray
#property indicator_levelstyle STYLE_SOLID

//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CMoving_Average   SmoothAlgorithms.mqh
CMoving_Average MA1,MA2,MA3;
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int RSI=10;      //  RSI
input int DeMarker=10; //  DeMarker
input int SPStep=4;    //  
input int FastMA=10;   //   
input int SlowMA=18;   //   
//+-----------------------------------+
//----      
int RSI_Handle[4],DEM_Handle[4];
//----      
int start,sp_start;
//----   ,    
//----      
double RSIBuffer[],DeMarkerBuffer[],SPBuffer[];
double FastMABuffer[],SlowMABuffer[],DiverBuffer[],ColorDiverBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----     
   int rsi_start=RSI+SPStep*3;
   int demark_start=DeMarker+SPStep*3;
   sp_start=MathMax(rsi_start,demark_start);
   start=sp_start+MathMax(FastMA,SlowMA);

//----      
   for(int numb=0; numb<4; numb++)
     {
      RSI_Handle[numb]=iRSI(NULL,0,RSI+SPStep*numb,PRICE_WEIGHTED);
      DEM_Handle[numb]=iDeMarker(NULL,0,DeMarker+SPStep*numb);
     }

//----    RSIBuffer[]   
   SetIndexBuffer(0,RSIBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,rsi_start);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----          
   ArraySetAsSeries(RSIBuffer,true);

//----    DeMarkerBuffer[]   
   SetIndexBuffer(1,DeMarkerBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,demark_start);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ,      
   ArraySetAsSeries(DeMarkerBuffer,true);

//----    SPBuffer[]   
   SetIndexBuffer(2,SPBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,sp_start);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ,      
   ArraySetAsSeries(SPBuffer,true);

//----    FastMABuffer[]   
   SetIndexBuffer(3,FastMABuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,sp_start);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ,      
   ArraySetAsSeries(FastMABuffer,true);

//----    SlowMABuffer[]   
   SetIndexBuffer(4,SlowMABuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,sp_start);
//----   ,      
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ,      
   ArraySetAsSeries(SlowMABuffer,true);

//----    DiverBuffer[]   
   SetIndexBuffer(5,DiverBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,start);
//----   ,      
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ,      
   ArraySetAsSeries(DiverBuffer,true);

//----    ColorDiverBuffer[]       
   SetIndexBuffer(6,ColorDiverBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,start+1);
//----    ,      
   ArraySetAsSeries(ColorDiverBuffer,true);

//----       
   MA1.MALengthCheck("RSI", RSI);
   MA1.MALengthCheck("DeMarker", DeMarker);
   MA1.MALengthCheck("FastMA", FastMA);
   MA1.MALengthCheck("SlowMA", SlowMA);

//----           
   IndicatorSetString(INDICATOR_SHORTNAME,"RSI DeMarker Super Position");
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+   
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<start) return(0);
   for(int numb=0; numb<4; numb++) if(BarsCalculated(RSI_Handle[numb])<rates_total) return(0);
   for(int numb=0; numb<4; numb++) if(BarsCalculated(DEM_Handle[numb])<rates_total) return(0);

//----   
   int limit,bar,to_copy,StartBar;
//----       
   double RSI0[],RSI1[],RSI2[],RSI3[],DEM0[],DEM1[],DEM2[],DEM3[],TmpDiver;

//----    ,     
   ArraySetAsSeries(RSI0,true);
   ArraySetAsSeries(RSI1,true);
   ArraySetAsSeries(RSI2,true);
   ArraySetAsSeries(RSI3,true);
   ArraySetAsSeries(DEM0,true);
   ArraySetAsSeries(DEM1,true);
   ArraySetAsSeries(DEM2,true);
   ArraySetAsSeries(DEM3,true);

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      limit=rates_total-sp_start;                        //      
     }
   else
     {
      limit=rates_total-prev_calculated;                //      
     }

   to_copy=limit+1;
   StartBar=rates_total-sp_start-1;

//----      
   if(CopyBuffer(RSI_Handle[0],0,0,to_copy,RSI0)<=0) return(0);
   if(CopyBuffer(RSI_Handle[1],0,0,to_copy,RSI1)<=0) return(0);
   if(CopyBuffer(RSI_Handle[2],0,0,to_copy,RSI2)<=0) return(0);
   if(CopyBuffer(RSI_Handle[3],0,0,to_copy,RSI3)<=0) return(0);
   if(CopyBuffer(DEM_Handle[0],0,0,to_copy,DEM0)<=0) return(0);
   if(CopyBuffer(DEM_Handle[1],0,0,to_copy,DEM1)<=0) return(0);
   if(CopyBuffer(DEM_Handle[2],0,0,to_copy,DEM2)<=0) return(0);
   if(CopyBuffer(DEM_Handle[3],0,0,to_copy,DEM3)<=0) return(0);

//----    
   for(bar=limit; bar>=0; bar--)
     {
      RSIBuffer[bar]=(RSI0[bar]+RSI1[bar]+RSI2[bar]+RSI3[bar])/400.0;
      DeMarkerBuffer[bar]=(DEM0[bar]+DEM1[bar]+DEM2[bar]+DEM3[bar])/4.0;
      //----
      SPBuffer[bar]=(RSIBuffer[bar]+DeMarkerBuffer[bar])/2;
      TmpDiver=DeMarkerBuffer[bar]-RSIBuffer[bar];
      //----
      FastMABuffer[bar] = MA1.MASeries(StartBar, prev_calculated, rates_total, FastMA, MODE_LWMA, SPBuffer[bar], bar, true);
      SlowMABuffer[bar] = MA2.MASeries(StartBar, prev_calculated, rates_total, SlowMA, MODE_LWMA, SPBuffer[bar], bar, true);
      DiverBuffer[bar]  = MA3.MASeries(StartBar, prev_calculated, rates_total, FastMA, MODE_LWMA, TmpDiver,      bar, true);
     }
//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      limit--;

//----    
   for(bar=limit; bar>=0; bar--)
     {
      ColorDiverBuffer[bar]=0;

      if(DiverBuffer[bar]>0)
        {
         if(DiverBuffer[bar]>DiverBuffer[bar+1]) ColorDiverBuffer[bar]=1;
         if(DiverBuffer[bar]<DiverBuffer[bar+1]) ColorDiverBuffer[bar]=2;
        }

      if(DiverBuffer[bar]<0)
        {
         if(DiverBuffer[bar]<DiverBuffer[bar+1]) ColorDiverBuffer[bar]=3;
         if(DiverBuffer[bar]>DiverBuffer[bar+1]) ColorDiverBuffer[bar]=4;
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+